with Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param, Paths, Renaming, Rep_Balls;
use Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param, Paths, Renaming, Param;
with FHN_Homoclinic.Faster, Paths;

pragma Elaborate_All (FHN_Homoclinic.Faster);
pragma Elaborate_All (Ada.Text_IO,Logicals,Globals,Ints,Rationals,Flts,Strings,Messages,Param,Renaming,Rep_Balls);

procedure Check_Segments is

  Deg_Taylor1:  constant Positive := 160;
  Deg_Taylor2:  constant Positive := 160;
  SPDeg1:       constant Positive := 9;
  
  package R_Home renames Rep_Balls;
  use R_Home;
  package FHN is new FHN_Homoclinic (Deg_Taylor1  => Deg_Taylor1,
                                     Deg_Taylor2  => Deg_Taylor2,
                                     SPDeg1 => SPDeg1,
                                     Real => Ball);
  package FHN_Faster is new FHN.Faster;
  use FHN;
  use Gen_Scalars;
  use C_Home;
  
  Shared: constant String := Input_Dir & "path";
  Locked: constant String := Input_Dir & "path.locked";
  Orig:   constant String := Input_Dir & "path.orig";
  
  Status: Integer := 0;
  P: Path := Read(Orig);
  
  procedure Summary is
  begin
    Rename_Shared(Shared,Locked);
    Read(Locked,P);
    Rename(Locked,Shared);
    Status := Min_Status(P);
    if Status>1 then
      Show0("QED");
    elsif Status=1 then
      Show0("Done - others still working");
    elsif Status=0 then
      Show0("weird ...");
    else
      Show0("test FAILED");
    end if;
  end Summary;
  
  I: Natural := 0;
  
begin
  Verbosity := 2;
  Set_Precisions(256);
  Set_Taylor2_Tasks(5);
  Show_Param;
  Show_Corners;
  
  loop
    Rename_Shared(Shared,Locked);
    Read(Locked,P);
    if I /= 0 then
      P(I).Status := Status;  -- previous germ
    end if;
    I := First_Status0(P);    -- new germ
    if I /= 0 then
      P(I).Status := 1;
    end if;
    Write(Locked,P);
    Rename(Locked,Shared);
    exit when I=0;
    Delta_Check_Segment(P(I));
    Status := P(I).Status;
  end loop;
  
  Summary;
  
end Check_Segments;
