with Ada.Text_IO, Strings, Ints, Flts, Globals, Param, Rep_Balls;
use Ada.Text_IO, Strings, Ints, Flts, Globals, Param, Rep_Balls;
with FHN_Periodic;

pragma Elaborate_All (Ada.Text_IO,Strings,Ints,Flts,Globals,Param,Rep_Balls);
pragma Elaborate_All (FHN_Periodic);

procedure CheckFix is

   Deg_Fourier1: constant Positive := 260;

   package FHN is new FHN_Periodic (Deg_Fourier1 => Deg_Fourier1, Real => Ball);

   use FHN;
   use RT1_Home, RT1_Fouriers1, RT1F_Periodic;
   
   Dim:  constant Positive := 60;                   -- must be even
   KMax:   constant Radius := Flt(3)/Flt(4);
   DVel:   constant Radius := Half**(60);
   P:   constant RT1_Param := SetParam(CApprox,DVel,F_Length);
   
   ST: RT1_Scalar;
   V1,V2,V3: RT1_Fourier1;

begin

   Set_Precisions(256);
   Verbosity := 1;
   Show_Param;
   
   Read(PData_Dir & "fixt.data",V1);
   Read(PData_Dir & "evt.data",V3);
   CheckFix(P,Dim,V1,V3,KMax);
   Write(PData_Dir & "fix.data",V1);
   
   MapA(P,V1,V2);
   Compo1(V3,V2,ST);
   
   if Sup(Val(ST,Scal(1)))<Zero and Inf(Val(ST,Scal(-1)))>Zero then
      Show0("ok");
   else
      raise Sorry with "ko";
   end if;

end CheckFix;
