with Ada.Text_IO, Globals, Ints, Flts, Strings, Rep_Balls;
use Ada.Text_IO, Globals, Ints, Flts, Strings, Rep_Balls;
with FHN_Periodic;

pragma Elaborate_All (Ada.Text_IO,Globals,Ints,Flts,Strings,Rep_Balls);
pragma Elaborate_All (FHN_Periodic);

procedure ECount is

   Deg_Fourier1: constant Positive := 100;

   package FHN is new FHN_Periodic (Deg_Fourier1 => Deg_Fourier1, Real => Ball);
   use FHN;
   use RT1_Fouriers1;

   Length: constant Flt := Flt(128);          -- period
   DVel:   constant Flt := Half**(60);        -- uncertainty on velocity
   
   N: Integer;
   FT: RT1_Fourier1;
   
begin

   Set_Precisions(512);
   Verbosity := 1;
   Show_Param;
   
   Read(PData_Dir & "fix.data",FT);
   N := CountEigen(DVel,Length,FT);
   Show1("possible non-contracting eigenvalues: ",N);

end ECount;
