
package body FHN_Homoclinic.Faster is
  
  procedure S2A(S: in R_Scalar; A: in out R_AScalar) is
    use R_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    PutStd(S,C,R); GetStd(C,R,A);
  end S2A;
  
  procedure A2S(A: in R_AScalar; S: in out R_Scalar) is
    use R_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    PutStd(A,C,R); GetStd(C,R,S);
  end A2S;
  
  procedure S2A(S: in R_Vector; A: in out R_AVector) is
    use R_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    for I in S'Range loop
      PutStd(S(I),C,R); GetStd(C,R,A(I));
    end loop;
  end S2A;

  procedure A2S(A: in R_AVector; S: in out R_Vector) is
    use R_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    for I in A'Range loop
      PutStd(A(I),C,R); GetStd(C,R,S(I));
    end loop;
  end A2S;
  
  procedure S2A(S: in R_Triangular; A: in out R_ATriangular) is
    use R_AHome;
    D: constant Integer := S'Last(1);
    C,R: Std_Floats.LLFloat;
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop
        PutStd(S(I,J),C,R); GetStd(C,R,A(I,J));
      end loop;
    end loop;
  end S2A;

  procedure A2S(A: in R_ATriangular; S: in out R_Triangular) is
    use R_AHome;
    D: constant Integer := A'Last(1);
    C,R: Std_Floats.LLFloat;
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop
        PutStd(A(I,J),C,R); GetStd(C,R,S(I,J));
      end loop;
    end loop;
  end A2S;
  
----------------------------
  
  procedure S2A(S: in C_Scalar; A: in out C_AScalar) is
    use C_Home, R_AHome, C_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    PutStd(S.Re,C,R); GetStd(C,R,A.Re);
    PutStd(S.Im,C,R); GetStd(C,R,A.Im);
  end S2A;
  
  procedure A2S(A: in C_AScalar; S: in out C_Scalar) is
    use C_Home, R_AHome, C_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    PutStd(A.Re,C,R); GetStd(C,R,S.Re);
    PutStd(A.Im,C,R); GetStd(C,R,S.Im);
  end A2S;
  
  procedure S2A(S: in C_Vector; A: in out C_AVector) is
    use C_Home, R_AHome, C_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    for I in S'Range loop
      PutStd(S(I).Re,C,R); GetStd(C,R,A(I).Re);
      PutStd(S(I).Im,C,R); GetStd(C,R,A(I).Im);
    end loop;
  end S2A;

  procedure A2S(A: in C_AVector; S: in out C_Vector) is
    use C_Home, R_AHome, C_AHome;
    C,R: Std_Floats.LLFloat;
  begin
    for I in A'Range loop
      PutStd(A(I).Re,C,R); GetStd(C,R,S(I).Re);
      PutStd(A(I).Im,C,R); GetStd(C,R,S(I).Im);
    end loop;
  end A2S;
  
  procedure S2A(S: in C_Triangular; A: in out C_ATriangular) is
    use C_Home, R_AHome, C_AHome;
    D: constant Integer := S'Last(1);
    C,R: Std_Floats.LLFloat;
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop
        PutStd(S(I,J).Re,C,R); GetStd(C,R,A(I,J).Re);
        PutStd(S(I,J).Im,C,R); GetStd(C,R,A(I,J).Im);
      end loop;
    end loop;
  end S2A;

  procedure A2S(A: in C_ATriangular; S: in out C_Triangular) is
    use C_Home, R_AHome, C_AHome;
    D: constant Integer := A'Last(1);
    C,R: Std_Floats.LLFloat;
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop
        PutStd(A(I,J).Re,C,R); GetStd(C,R,S(I,J).Re);
        PutStd(A(I,J).Im,C,R); GetStd(C,R,S(I,J).Im);
      end loop;
    end loop;
  end A2S;
  
----------------------------
  
  procedure S2A(S: in RT1_Scalar; A: in out RT1_AScalar) is
  begin
    S2A(S.C,A.C);
    A.F := S.F;
    A.R := S.R;
  end S2A;

  procedure A2S(A: in RT1_AScalar; S: in out RT1_Scalar) is
  begin
    A2S(A.C,S.C);
    S.F := A.F;
    S.R := A.R;
  end A2S;
  
  procedure S2A(S: in RT1_Vector; A: in out RT1_AVector) is
  begin
    for I in S'Range loop S2A(S(I),A(I)); end loop;
  end S2A;

  procedure A2S(A: in RT1_AVector; S: in out RT1_Vector) is
  begin
    for I in A'Range loop A2S(A(I),S(I)); end loop;
  end A2S;
  
  procedure S2A(S: in RT1_Triangular; A: in out RT1_ATriangular) is
    D: constant Integer := S'Last(1);
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop S2A(S(I,J),A(I,J)); end loop;
    end loop;
  end S2A;

  procedure A2S(A: in RT1_ATriangular; S: in out RT1_Triangular) is
    D: constant Integer := A'Last(1);
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop A2S(A(I,J),S(I,J)); end loop;
    end loop;
  end A2S;
  
-------------------------
  
  procedure S2A(S: in CT1_Scalar; A: in out CT1_AScalar) is
  begin
    S2A(S.C,A.C);
    A.F := S.F;
    A.R := S.R;
  end S2A;

  procedure A2S(A: in CT1_AScalar; S: in out CT1_Scalar) is
  begin
    A2S(A.C,S.C);
    S.F := A.F;
    S.R := A.R;
  end A2S;
  
  procedure S2A(S: in CT1_Vector; A: in out CT1_AVector) is
  begin
    for I in S'Range loop S2A(S(I),A(I)); end loop;
  end S2A;

  procedure A2S(A: in CT1_AVector; S: in out CT1_Vector) is
  begin
    for I in A'Range loop A2S(A(I),S(I)); end loop;
  end A2S;
  
  procedure S2A(S: in CT1_Triangular; A: in out CT1_ATriangular) is
    D: constant Integer := S'Last(1);
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop S2A(S(I,J),A(I,J)); end loop;
    end loop;
  end S2A;

  procedure A2S(A: in CT1_ATriangular; S: in out CT1_Triangular) is
    D: constant Integer := A'Last(1);
  begin
    for I in 0 .. D loop
      for J in 0 .. D-I loop A2S(A(I,J),S(I,J)); end loop;
    end loop;
  end A2S;
  
------------------------------------------------------------------
--- the real stuff -----------------------------------------------
------------------------------------------------------------------
  
  procedure Fast_Prod_Err(C1,C2: in C_Poly2; D1,D2: in Natural; R: in Radius; E: in out C_EVector) is
    use C_APolynoms2;
    AC1,AC2: C_APoly2;
    AE: C_AEVector;
  begin
    S2A(C1,AC1);
    S2A(C2,AC2);
    Prod_Err(AC1,AC2,D1,D2,R,AE);
    A2S(AE,E);
  end Fast_Prod_Err;
  
  procedure Fast_Prod_Err(C1,C2: in CT1_Poly2; D1,D2: in Natural; R: in Radius; E: in out CT1_EVector) is
    use CT1_APolynoms2;
    AC1,AC2: CT1_APoly2;
    AE: CT1_AEVector;
  begin
    CT1_AHome.Rad := CT1_Home.Rad;
    S2A(C1,AC1);
    S2A(C2,AC2);
    Prod_Err(AC1,AC2,D1,D2,R,AE);
    A2S(AE,E);
  end Fast_Prod_Err;
  
begin
  
  C_APolynoms2.Prod_Tasks := C_Polynoms2.Prod_Tasks;
  CT1_APolynoms2.Prod_Tasks := CT1_Polynoms2.Prod_Tasks;
  
  if not Stand then
    C_Polynoms2.A_Prod_Err := Fast_Prod_Err'Access;
    CT1_Polynoms2.A_Prod_Err := Fast_Prod_Err'Access;
  end if;
  
end FHN_Homoclinic.Faster;
