with Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param, Rep_Balls;
use Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param;
with FHN_Homoclinic.Faster;

pragma Elaborate_All (FHN_Homoclinic.Faster);
pragma Elaborate_All (Ada.Text_IO,Logicals,Globals,Ints,Rationals,Flts,Strings,Messages,Param,Rep_Balls);

procedure Find_Intersection is

  Deg_Taylor1: constant Positive := 255;
  Deg_Taylor2: constant Positive := 255;
  SPDeg1:      constant Positive := 2;

  package R_Home renames Rep_Balls;
  use R_Home;
  package FHN is new FHN_Homoclinic (Deg_Taylor1 => Deg_Taylor1,
                                     Deg_Taylor2 => Deg_Taylor2,
                                     SPDeg1 => SPDeg1,
                                     Real => Ball);
  package FHN_Faster is new FHN.Faster;
  use FHN;
  use C_Home, Gen_Scalars;

  R0: constant Radius := Flt(1)/Flt(32);
  R:  constant Radius := Half**96;
  C: R_Scalar;
  S: C_Scalar;

begin
  Verbosity := 2;
  Set_Precisions(320);
  Set_Taylor2_Tasks(5);
  Show_Param;
  
  Read(Input_Dir & "approx-c",C);
  Center(C);
  Read(Input_Dir & "approx-s",S);
  Center(S);
  Find_Homoclinic(R,C,S); --- R just for testing

end Find_Intersection;
