
package Globals is

  type Rounding_Direction is (Up, Down, Nearest, Truncate);
  type Rounding_Mask is (Strict, Relaxed);

  type Rounding_Mode is
    record
      Direction: Rounding_Direction := Nearest;
      Mask: Rounding_Mask := Relaxed;
    end record;
  
  type Scalar_Info is
    record
      RepType:    String(1..10);
      IsStandard: Boolean := True;
      IsNumeric:  Boolean := True;
      IsComplex:  Boolean := False;
      NReps:      Natural := 1;
    end record;
  
  Initial_Precision: constant Positive := 512;    --- used during elaboration
  FConst:            constant Positive := 16384;  --- used by Taylors
  
  CheckRange: Boolean := False; -- for matrices and vectors
  Verbosity:  Natural  := 0;    -- 0: just error messages and important warnings
                                -- 1: also high level program info
                                -- 2: also TraceEnter and TraceLeave
                                -- 3: also domain errors with info in numeric programs
                                -- 4: more stuff
                                -- 5: almost everything
                                -- 6: insane

  Domain_Error, Dimension_Error, Undefined, Not_Implemented, Sorry: exception;

  PData_Dir:  constant String := "pdata/";
  Input_Dir:  constant String := "hdata/";
  Output_Dir: constant String := "hdata/";
  
end Globals;
