with Tasks;

pragma Elaborate_All (Tasks);

package body Ints is
  
  package Txt_IO renames Ada.Text_IO;
  
  function IMin(I1,I2,I3: Integer) return Integer is
  begin
    return IMin(IMin(I1,I2),I3);
  end IMin;

  function IMax(I1,I2,I3: Integer) return Integer is
  begin
    return IMax(IMin(I1,I2),I3);
  end IMax;

  function Choose(ChooseN0: Boolean; N0,N1: Integer) return Integer is
  begin
    if ChooseN0 then return N0; else return N1; end if;
  end Choose;

  function IntVal(B: Boolean) return Integer is
  begin
    if B then return 1; else return 0; end if;
  end IntVal;

  function Binomial(N,M: Positive) return Positive is
    K: constant Positive := IMax(M,N-M);
    B: Positive := 1;
  begin
    for J in 1 .. N-K loop
      B := (B*(K+J))/J;
    end loop;
    return B;
  end Binomial;

  function Convert(K: Integer) return Integer is
  begin
    return K;
  end Convert;

---------------------------------------------
  
  procedure Put(P: in File_Access; I: in Integer; Width : in Field := Int_IO.Default_Width) is
  begin
    if P=null then
      Int_IO.Put(I,Width);
    else
      Int_IO.Put(P.all,I,Width);
    end if;
  end Put;

  procedure Put(F: in File_Type; I: in Integer; Dummy: in Boolean := False) is
    pragma Unreferenced(Dummy);
    use Strings;
  begin
    Int_IO.Put(F,I,Width(I)+1);
    New_Line(F);
  end Put;

  procedure Get(F: in File_Type; I: in out Integer; Dummy: in Boolean := False) is
    pragma Unreferenced(Dummy);
  begin
    Int_IO.Get(F,I);
  end Get;

  function Read(FileName: in String) return Integer is
    I: Integer;
    F: File_Type;
  begin
    Open(F,In_File,FileName);
    Int_IO.Get(F,I);
    Close(F);
    return I;
  end Read;
  
  procedure Show1(N: in String; I: in Integer; NewLine: in Boolean := True) is
    use Tasks,Strings;
    P: constant File_Access := Task_Log;
  begin
    Put(P,N);
    Put(P,I,Width(I)+1);
    if NewLine then Flush_New_Line(P); end if;
  end Show1;

  procedure Show2(N: in String; I1,I2: in Integer; NewLine: in Boolean := True) is
    use Tasks,Strings;
    P: constant File_Access := Task_Log;
  begin
    Put(P,N);
    Put(P,I1,Width(I1)+1);
    Put(P,I2,Width(I2)+5);
    if NewLine then Flush_New_Line(P); end if;
  end Show2;    

end Ints;
