with Ada.Text_IO, Strings, AddETC, Matrices, Vectors;
use Ada.Text_IO;

pragma Elaborate_All (Ada.Text_IO,Strings,AddETC,Matrices,Vectors);

package Ints is

  function IMin(I1,I2: Integer) return Integer renames Integer'Min;
  function IMax(I1,I2: Integer) return Integer renames Integer'Max;
  function IMin(I1,I2,I3: Integer) return Integer;
  function IMax(I1,I2,I3: Integer) return Integer;
  function Choose(ChooseN0: Boolean; N0,N1: Integer) return Integer;
  function IntVal(B: Boolean) return Integer;
  function Binomial(N,M: Positive) return Positive;
  function Convert(K: Integer) return Integer;
  
  package Int_IO renames Strings.Int_IO;
  
  procedure Put(P: in File_Access; I: in Integer; Width : in Field := Int_IO.Default_Width);
  procedure Put(F: in File_Type; I: in Integer; Dummy: in Boolean := False);     --- includes New_Line
  procedure Get(F: in File_Type; I: in out Integer; Dummy: in Boolean := False);
  function Read(FileName: in String) return Integer;
  procedure Show1(N: in String; I: in Integer; NewLine: in Boolean := True);
  procedure Show2(N: in String; I1,I2: in Integer; NewLine: in Boolean := True);
  
  subtype OneTwo is Integer range 1 .. 2;
  subtype OneTwoThree is Integer range 1 .. 3;
  subtype Negative is Integer range Integer'First .. -1;
  
  package IAE is new AddETC (Number => Integer);
  use IAE;
  
  package IM is new Matrices (Scalar => Integer);
  package IV is new Vectors (Scalar => Integer, Component => Integer, SM => IM);

  subtype IntVec is IV.Vector;
  subtype IntMat is IM.Matrix;

end Ints;
