with Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param, Reps;
use Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param;
with FHN_Homoclinic;

pragma Elaborate_All (FHN_Homoclinic);
pragma Elaborate_All (Ada.Text_IO,Logicals,Globals,Ints,Rationals,Flts,Strings,Messages,Param,Reps);

procedure Iterate_Homoclinic is -- iterate to improve numerical data

  Deg_Taylor1:  constant Positive := 255;
  Deg_Taylor2:  constant Positive := 255;
  SPDeg1:       constant Positive := 2;

  package R_Home renames Reps;
  use R_Home;
  package FHN is new FHN_Homoclinic (Deg_Taylor1  => Deg_Taylor1,
                                     Deg_Taylor2  => Deg_Taylor2,
                                     SPDeg1 => SPDeg1,
                                     Real => Reps.Rep);
  use FHN;

  Iter: constant Integer := 16;
  R0: constant Radius := Flt(1)/Flt(32);
  R: constant Radius := Half**96;

begin
  Verbosity := 5;
  Set_Precisions(512);
  Set_Newton_Parallel(False);
  Set_Taylor2_Tasks(5);
  Show_Param;

  Iter_Find_Homoclinic(R0,R,Iter);

end Iterate_Homoclinic;
