with Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param, Rep_Balls;
use Ada.Text_IO, Logicals, Globals, Ints, Rationals, Flts, Strings, Messages, Param;
with FHN_Homoclinic.Faster;

pragma Elaborate_All (FHN_Homoclinic.Faster);
pragma Elaborate_All (Ada.Text_IO,Logicals,Globals,Ints,Rationals,Flts,Strings,Messages,Param,Rep_Balls);

procedure Make_Unstable is

  Deg_Taylor2: constant Positive := 255;
  SPDeg1:      constant Positive := 2;

  package R_Home renames Rep_Balls;
  use R_Home;
  package FHN is new FHN_Homoclinic (Deg_Taylor2  => Deg_Taylor2, SPDeg1 => SPDeg1, Real => Ball);
  package FHN_Faster is new FHN.Faster;
  use FHN;
  use Gen_Scalars;

  R0: constant Radius := Flt(1)/Flt(32);
  C: R_Scalar;

begin
  Verbosity := 2;
  Set_Precisions(320);
  Set_Taylor2_Tasks(5);
  Show_Param;
  
  Read(Input_Prefix & "c",C);
  Write_C_Unstable(Output_Prefix & "c_unstable",C,R0);

end Make_Unstable;
