with Ada.Text_IO, Globals, Ints, Flts, Strings, Param, Rep_Balls;
use Ada.Text_IO, Globals, Ints, Flts, Strings, Param;
with FHN_Homoclinic.Faster;

pragma Elaborate_All (FHN_Homoclinic.Faster);
pragma Elaborate_All (Ada.Text_IO,Globals,Ints,Flts,Strings,Param,Rep_Balls);

procedure Make_Unstable0 is

  Deg_Taylor2: constant Positive := 255;
  SPDeg1:      constant Positive := 2;
  
  package R_Home renames Rep_Balls;
  use R_Home;
  package FHN is new FHN_Homoclinic (Deg_Taylor2  => Deg_Taylor2, SPDeg1 => SPDeg1, Real => Ball);
  package FHN_Faster is new FHN.Faster;
  use FHN;
  use Gen_Scalars;

  R0: constant Radius   := Flt(1)/Flt(32);
  R:  constant Radius   := Half**96;
  C:  constant R_Scalar := CApprox;

begin
  Verbosity := 2;
  Set_Precisions(320);
  Set_Taylor2_Tasks(5);
  Show_Param;

  Write_CT1_Unstable0(Output_Prefix & "ct1_unstable0",C,R0,R);

end Make_Unstable0;
