
package MPFR.Floats.Rounding is --- used in Balls
  
  procedure Set_Rounding_Mode(Dummy: in MPFloat; M: in Rounding_Mode);
  
  procedure Enclose(S: in MPFloat; C,R: out LLFloat);
  procedure AddErr(I: in Integer; S: in out MPFloat; Err: out LLFloat);
  procedure AddErr(S1: in MPFloat; S2: in out MPFloat; Err: out LLFloat);
  procedure SumErr(S1,S2: in MPFloat; S3: in out MPFloat; Err: out LLFloat);
  procedure SubErr(S1: in MPFloat; S2: in out MPFloat; Err: out LLFloat);
  procedure DiffErr(S1,S2: in MPFloat; S3: in out MPFloat; Err: out LLFloat);
  procedure MultErr(R: in Flt; S,Tmp: in out MPFloat; Err: out LLFloat);
  procedure ProdErr(R: in Flt; S1: in MPFloat; S2: in out MPFloat; Err: out LLFloat);
  procedure MultErr(S1: in MPFloat; S2: in out MPFloat; Err: out LLFloat);
  procedure ProdErr(S1,S2: in MPFloat; S3: in out MPFloat; Err: out LLFloat);
  procedure AddProdErr(R: in Flt; S1: in MPFloat; S2,Tmp: in out MPFloat; Err: out LLFloat);
  procedure AddProdErr(S1,S2: in MPFloat; S3,Tmp: in out MPFloat; Err: out LLFloat);
  procedure AddProdErr(S1,S2: in MPFloat; S3: in out MPFloat; Err: out LLFloat);
  procedure SumProdErr(S1,S2,S3: in MPFloat; S4: in out MPFloat; Err: out LLFloat);
  procedure SubProdErr(S1,S2: in MPFloat; S3,Tmp: in out MPFloat; Err: out LLFloat);
  procedure DivErr(R: in Flt; S,Tmp: in out MPFloat; Err: out LLFloat);
  procedure QuotErr(S1: in MPFloat; R: in Flt; S2: in out MPFloat; Err: out LLFloat);
  procedure InvErr(S1: in MPFloat; S2: in out MPFloat; Err: out LLFloat);
  
  procedure Root(K: in Positive; X,DX: in MPFloat; YL,YU: in out MPFloat);
  procedure ExpUp(X: in MPFloat; Y: in out MPFloat);
  procedure ExpDown(X: in MPFloat; Y: in out MPFloat);
  procedure Exp(X,DX: in MPFloat; YL,YU: in out MPFloat);
  procedure Log(X,DX: in MPFloat; YL,YU: in out MPFloat);
  procedure ArcCos(X,DX: in MPFloat; YL,YU: in out MPFloat);
  procedure ArcSin(X,DX: in MPFloat; YL,YU: in out MPFloat);
  procedure Cos(X: in MPFloat; YL,YU: in out MPFloat);
  procedure Sin(X: in MPFloat; YL,YU: in out MPFloat);
  
private
  
  function ULP_Weight(V: MPFR_T) return LLFloat;
  
end MPFR.Floats.Rounding;
