with ScalVectors.Homoclinic;

pragma Elaborate_All (ScalVectors.Homoclinic);

generic
  
  with procedure HiErrs(S: in out Scalar) is <>;
  
package MultiTaylors2.Homoclinic is
  
  package SSVH is new SSV.Homoclinic;
  use ST2, SSVH;
  
  subtype Scalar_Cubic1 is SSVH.Cubic1;
  type Simple_Operator2 is array (0..PDeg,0..PDeg) of Scalar_Matrix3;
  
  procedure Neg(T: in out Simple_Operator2);
  procedure Mult(T: in Simple_Operator2; M,N: in OneTwoThree; P: in out Taylor2_Vector3);
  procedure Mult(T: in Simple_Operator2; P: in out Taylor2_Vector3);
  procedure Local_Unstable(D: in FHN_Data0; R0: in Radius; Phi: in out Taylor2_Vector3);
  procedure Local_Unstable(C: in Scalar; R0: in Radius; Phi: in out Taylor2_Vector3);
  procedure Local_Unstable(C,S: in Scalar; W: in out Scalar_Vector3);
  procedure DLocal_Unstable(C,S: in Scalar; W1,W2: in out Scalar_Vector3);
  procedure Plot_Unstable(C: in Scalar; R0: in Flt; Phi: in out Taylor2_Vector3);
  procedure Plot_Unstable(C: in Scalar; R0: in Flt);
  
  procedure Spec_Local_Unstable(C,Z: in Scalar; Phi2: in Taylor2; V: in out Taylor2_Vector3);
  procedure Spec_Local_Unstable(C,Z,S: in Scalar; Phi2: in Taylor2; W: in out Scalar_Vector3);
  
private
  
  procedure InvHi(M,N: in Natural; Nu: in Scalar; E: in out Scalar);
  procedure InvDyMinusM(Nu0: in Scalar; M: in Scalar_Matrix3; T: in out Simple_Operator2; D0: in Natural);
  procedure FpDiff(Phi2: in Taylor2; P12,PTmp: in out Taylor2);
  
end MultiTaylors2.Homoclinic;
