
package body Rationals is

  function Rat(N,D: Integer) return Rational is
    Q: Rational;
    QN: Integer renames Q.Num;
    QD: Integer renames Q.Den;
    M: Integer;
  begin
    QN := abs(N);
    QD := abs(D);
    while (QN /= 0) loop
      M  := QN;
      QN := QD mod M;
      QD := M;
    end loop;   --- now QD=GCD(N,D)
    if D<0 then
      QN := (-N)/QD;
      QD := (-D)/QD;
    else
      QN := N/QD;
      QD := D/QD;
    end if;
    return Q;
  end Rat;
  
  function Num(Q: Rational) return Integer is
  begin
    return Q.Num;
  end Num;
  
  function Den(Q: Rational) return Integer is
  begin
    return Q.Den;
  end Den;
  
  function "-"(Q: Rational) return Rational is
  begin
    return (-Q.Num,Q.Den);
  end "-";
  
  function "+"(I: Integer; Q: Rational) return Rational is
  begin
    return (I*Q.Den+Q.Num)/Q.Den;
  end "+";
  
  function "+"(Q: Rational; I: Integer) return Rational is
  begin
    return (Q.Num+I*Q.Den)/Q.Den;
  end "+";
  
  function "+"(P,Q: Rational) return Rational is
  begin
    return (P.Num*Q.Den+P.Den*Q.Num)/(P.Den*Q.Den);
  end "+";
  
  function "-"(I: Integer; Q: Rational) return Rational is
  begin
    return (I*Q.Den-Q.Num)/Q.Den;
  end "-";
  
  function "-"(Q: Rational; I: Integer) return Rational is
  begin
    return (Q.Num-I*Q.Den)/Q.Den;
  end "-";
  
  function "-"(P,Q: Rational) return Rational is
  begin
    return (P.Num*Q.Den-P.Den*Q.Num)/(P.Den*Q.Den);
  end "-";
  
  function "*"(I: Integer; Q: Rational) return Rational is
  begin
    return (I*Q.Num)/Q.Den;
  end "*";
  
  function "*"(Q: Rational; I: Integer) return Rational is
  begin
    return (Q.Num*I)/Q.Den;
  end "*";
  
  function "*"(P,Q: Rational) return Rational is
  begin
    return (P.Num*Q.Num)/(P.Den*Q.Den);
  end "*";

  function "/"(I: Integer; Q: Rational) return Rational is
  begin
    return (I*Q.Den)/Q.Num;
  end "/";
  
  function "/"(Q: Rational; I: Integer) return Rational is
  begin
    return Q.Num/(Q.Den*I);
  end "/";
  
  function "/" (P,Q: Rational) return Rational is
  begin
   return (P.Num*Q.Den)/(P.Den*Q.Num);
  end "/";
  
  function "abs"(Q: Rational) return Rational is
  begin
    return (abs(Q.Num),Q.Den);
  end "abs";
  
end Rationals;
