with Ints;
use Ints;

package Rationals is  --- not for major computations

  type Rational is private;
  
  function Rat(N,D: Integer) return Rational;
  function Num(Q: Rational) return Integer;
  function Den(Q: Rational) return Integer;
  function "-"(Q: Rational) return Rational;
  function "+"(I: Integer; Q: Rational) return Rational;
  function "+"(Q: Rational; I: Integer) return Rational;
  function "+"(P,Q: Rational) return Rational;
  function "-"(I: Integer; Q: Rational) return Rational;
  function "-"(Q: Rational; I: Integer) return Rational;
  function "-"(P,Q: Rational) return Rational;
  function "*"(I: Integer; Q: Rational) return Rational;
  function "*"(Q: Rational; I: Integer) return Rational;
  function "*"(P,Q: Rational) return Rational;
  function "/"(M,N: Integer) return Rational renames Rat;
  function "/"(I: Integer; Q: Rational) return Rational;
  function "/"(Q: Rational; I: Integer) return Rational;
  function "/" (P,Q: Rational) return Rational;
  function "abs"(Q: Rational) return Rational;
  
private
  
  type Rational is
    record
      Num : Integer;
      Den : Positive;  --- with GCD(Num,Den)=1
    end record;
  
end Rationals;
