with Ada.Text_IO, Globals, Ints, Flts, Strings, Rep_Balls;
use Ada.Text_IO, Globals, Ints, Flts, Strings, Rep_Balls;
with FHN_Periodic;

pragma Elaborate_All (Ada.Text_IO,Globals,Ints,Flts,Strings,Rep_Balls);
pragma Elaborate_All (FHN_Periodic);

procedure Spectrum is

   Deg_Fourier1: constant Positive := 120;
   
   package FHN is new FHN_Periodic (Deg_Fourier1 => Deg_Fourier1, Real => Ball);
   use FHN;
   use RT1_Fouriers1;
   
   Length:  constant Flt    := Flt(128);          -- period
   DVel:    constant Flt    := Half**(60);        -- uncertainty on velocity
   MaxImag: constant Radius := Flt(3)/Flt(8);     -- upper bound on the imaginary part
   
   FT: RT1_Fourier1;
   
begin
  
--   Set_Precisions(64);
   Verbosity := 2;
   Show_Param;
   
   Read(PData_Dir & "fix.data",FT);
   CheckLinear(DVel,Length,FT,Scal(-MaxImag),Scal(MaxImag));
   Show0("ok");
   
end Spectrum;
