with MPFR.Floats.Rounding;

pragma Elaborate_All (MPFR.Floats.Rounding);

package body Std_Floats.Plus is

  use MPFR.Floats, MPFR.Floats.Rounding;
  
  procedure Root(K: in Positive; X,DX: in LLFloat; YL,YU: in out LLFloat) is
    S,DS,TL,TU: MPFloat;
  begin
    Val(X,S);
    Val(DX,DS);
    Root(K,S,DS,TL,TU);
    YL := Lower(TL);
    YU := Upper(TU);
  end Root;
  
  function ExpUp(X: LLFloat) return LLFloat is
    S,T: MPFloat;
  begin
    Val(X,S);
    ExpUp(S,T);
    return Upper(T);
  end ExpUp;
  
  function ExpDown(X: LLFloat) return LLFloat is
    S,T: MPFloat;
  begin
    Val(X,S);
    ExpDown(S,T);
    return Lower(T);
  end ExpDown;

  procedure Exp(X,DX: in LLFloat; YL,YU: in out LLFloat) is
    S,DS,TL,TU: MPFloat;
  begin
    Val(X,S);
    Val(DX,DS);
    Exp(S,DS,TL,TU);
    YL := Lower(TL);
    YU := Upper(TU);
  end Exp;
  
  procedure Log(X,DX: in LLFloat; YL,YU: in out LLFloat) is
    S,DS,TL,TU: MPFloat;
  begin
    Val(X,S);
    Val(DX,DS);
    Log(S,DS,TL,TU);
    YL := Lower(TL);
    YU := Upper(TU);
  end Log;

  procedure ArcCos(X,DX: in LLFloat; YL,YU: in out LLFloat) is
    S,DS,TL,TU: MPFloat;
  begin
    Val(X,S);
    Val(DX,DS);
    ArcCos(S,DS,TL,TU);
    YL := Lower(TL);
    YU := Upper(TU);
  end ArcCos;

  procedure ArcSin(X,DX: in LLFloat; YL,YU: in out LLFloat) is
    S,DS,TL,TU: MPFloat;
  begin
    Val(X,S);
    Val(DX,DS);
    ArcSin(S,DS,TL,TU);
    YL := Lower(TL);
    YU := Upper(TU);
  end ArcSin;

  procedure Cos(X: in LLFloat; YL,YU: in out LLFloat) is
    S,TL,TU: MPFloat;
  begin
    Val(X,S);
    Cos(S,TL,TU);
    YL := Lower(TL);
    YU := Upper(TU);
  end Cos;

  procedure Sin(X: in LLFloat; YL,YU: in out LLFloat) is
    S,TL,TU: MPFloat;
  begin
    Val(X,S);
    Sin(S,TL,TU);
    YL := Lower(TL);
    YU := Upper(TU);
  end Sin;
  
end Std_Floats.Plus;
