
package body Std_Floats.Rounding is

  procedure Set_Rounding_Mode(Dummy: in LLFloat; M: in Rounding_Mode) is
    pragma Unreferenced (Dummy);
  begin
    FPU_Rounding.Set_Rounding_Mode(M);
  end Set_Rounding_Mode;
  
  procedure AddErr(I: in Integer; S: in out LLFloat; Err: out LLFloat) is
  begin
    Err := LLFloat(-I)-S;
    S := LLFloat(I)+S;
    Err := S+Err;
  end AddErr;

  procedure AddErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat) is
  begin
    Err := -S1-S2;
    S2 := S1+S2;
    Err := S2+Err;
  end AddErr;

  procedure SumErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat) is
  begin
    S3 := S1+S2;
    Err := S3+(-S1-S2);
  end SumErr;

  procedure SubErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat) is
  begin
    Err := S1-S2;
    S2 := S2-S1;
    Err := S2+Err;
  end SubErr;

  procedure DiffErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat) is
  begin
    S3 := S1-S2;
    Err := S3+(S2-S1);
  end DiffErr;

  procedure MultErr(R: in Flt; S,Dummy: in out LLFloat; Err: out LLFloat) is
    pragma Unreferenced(Dummy);
  begin
    Err := LLFloat(-R)*S;
    S := LLFloat(R)*S;
    Err := S+Err;
  end MultErr;

  procedure ProdErr(R: in Flt; S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat) is
  begin
    S2 := LLFloat(R)*S1;
    Err := S2+LLFloat(-R)*S1;
  end ProdErr;

  procedure MultErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat) is
  begin
    Err := (-S1)*S2;
    S2 := S1*S2;
    Err := S2+Err;
  end MultErr;

  procedure ProdErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat) is
  begin
    S3 := S1*S2;
    Err := S3+((-S1)*S2);
  end ProdErr;

  procedure AddProdErr(R: in Flt; S1: in LLFloat; S2,Dummy: in out LLFloat; Err: out LLFloat) is
    pragma Unreferenced(Dummy);
  begin
    Err := LLFloat(-R)*S1-S2;
    S2 := LLFloat(R)*S1+S2;
    Err := S2+Err;
  end AddProdErr;

  procedure AddProdErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat) is
  begin
    Err := (-S1)*S2-S3;
    S3 := S1*S2+S3;
    Err := S3+Err;
  end AddProdErr;
  
  procedure AddProdErr(S1,S2: in LLFloat; S3,Dummy: in out LLFloat; Err: out LLFloat) is
    pragma Unreferenced(Dummy);
  begin
    Err := (-S1)*S2-S3;
    S3 := S1*S2+S3;
    Err := S3+Err;
  end AddProdErr;

  procedure SumProdErr(S1,S2,S3: in LLFloat; S4: in out LLFloat; Err: out LLFloat) is
  begin
    S4 := S1*S2+S3;
    Err := S4+((-S1)*S2-S3);
  end SumProdErr;

  procedure SubProdErr(S1,S2: in LLFloat; S3,Dummy: in out LLFloat; Err: out LLFloat) is
    pragma Unreferenced(Dummy);
  begin
    Err := S1*S2-S3;
    S3 := S3+(-S1)*S2;
    Err := S3+Err;
  end SubProdErr;

  procedure DivErr(R: in Flt; S,Dummy: in out LLFloat; Err: out LLFloat) is
    pragma Unreferenced(Dummy);
  begin
    Err := S/LLFloat(-R);
    S := S/LLFloat(R);
    Err := S+Err;
  end DivErr;

  procedure QuotErr(S1: in LLFloat; R: in Flt; S2: in out LLFloat; Err: out LLFloat) is
  begin
    Err := S1/LLFloat(-R);
    S2 := S1/LLFloat(R);
    Err := S2+Err;
  end QuotErr;

  procedure InvErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat) is
  begin
    S2 := LLFloat(1)/S1;
    Err := S2+LLFloat(-1)/S1;
  end InvErr;
  
end Std_Floats.Rounding;
