with FPU_Rounding, Std_Floats.Plus;

pragma Elaborate_All (FPU_Rounding,Std_Floats.Plus);

package Std_Floats.Rounding is --- used in Balls, runs in round-up mode
  
  procedure Set_Rounding_Mode(Dummy: in LLFloat; M: in Rounding_Mode);
  
  procedure Enclose(S: in LLFloat; C,R: out LLFloat) renames PutStd;
  procedure AddErr(I: in Integer; S: in out LLFloat; Err: out LLFloat);
  procedure AddErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat);
  procedure SumErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat);
  procedure SubErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat);
  procedure DiffErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat);
  procedure MultErr(R: in Flt; S,Dummy: in out LLFloat; Err: out LLFloat);
  procedure ProdErr(R: in Flt; S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat);
  procedure MultErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat);
  procedure ProdErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat);
  procedure AddProdErr(R: in Flt; S1: in LLFloat; S2,Dummy: in out LLFloat; Err: out LLFloat);
  procedure AddProdErr(S1,S2: in LLFloat; S3,Dummy: in out LLFloat; Err: out LLFloat);
  procedure AddProdErr(S1,S2: in LLFloat; S3: in out LLFloat; Err: out LLFloat);
  procedure SumProdErr(S1,S2,S3: in LLFloat; S4: in out LLFloat; Err: out LLFloat);
  procedure SubProdErr(S1,S2: in LLFloat; S3,Dummy: in out LLFloat; Err: out LLFloat);
  procedure DivErr(R: in Flt; S,Dummy: in out LLFloat; Err: out LLFloat);
  procedure QuotErr(S1: in LLFloat; R: in Flt; S2: in out LLFloat; Err: out LLFloat);
  procedure InvErr(S1: in LLFloat; S2: in out LLFloat; Err: out LLFloat);

  procedure Root(K: in Positive; X,DX: in LLFloat; YL,YU: in out LLFloat) renames Std_Floats.Plus.Root;
  procedure Exp(X,DX: in LLFloat; YL,YU: in out LLFloat) renames Std_Floats.Plus.Exp;
  procedure Log(X,DX: in LLFloat; YL,YU: in out LLFloat) renames Std_Floats.Plus.Log;
  procedure ArcCos(X,DX: in LLFloat; YL,YU: in out LLFloat) renames Std_Floats.Plus.ArcCos;
  procedure ArcSin(X,DX: in LLFloat; YL,YU: in out LLFloat) renames Std_Floats.Plus.ArcSin;
  procedure Cos(X: in LLFloat; YL,YU: in out LLFloat) renames Std_Floats.Plus.Cos;
  procedure Sin(X: in LLFloat; YL,YU: in out LLFloat) renames Std_Floats.Plus.Sin;
  
end Std_Floats.Rounding;
