
package body Triangulars.TGeneric is
  
  subtype Power is Integer range 0 .. PDeg;
  
  procedure TP_Modify1(T: in out Triangular) is
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop Modify1(T(I,J)); end loop;
    end loop;
  end TP_Modify1;
  
  procedure TP_Modify2(T1,T2: in out Triangular) is
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop Modify2(T1(I,J),T2(I,J)); end loop;
    end loop;
  end TP_Modify2;
  
  procedure TP_Map1(T1: in Triangular; T2: in out Triangular) is
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop Map1(T1(I,J),T2(I,J)); end loop;
    end loop;
  end TP_Map1;
  
  function TF_Map1(T: Triangular) return Triangular is
    W: Triangular(T'Range(1),T'Range(2));
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop Map1(T(I,J),W(I,J)); end loop;
    end loop;
    return W;
  end TF_Map1;
  
  procedure TP_Map2(T1,T2: in Triangular; T3: in out Triangular) is
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop Map2(T1(I,J),T2(I,J),T3(I,J)); end loop;
    end loop;
  end TP_Map2;
  
  function TF_Map2(T1,T2: Triangular) return Triangular is
    T3: Triangular(T2'Range(1),T2'Range(2));
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop Map2(T1(I,J),T2(I,J),T3(I,J)); end loop;
    end loop;
    return T3;
  end TF_Map2;
  
  function TF_BProperty(T: Triangular) return Boolean is
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop
        if not BProperty(T(I,J)) then return False; end if;
      end loop;
    end loop;
    return True;
  end TF_BProperty;
  
  function TF_LProperty(T: Triangular) return Logical is
    L: Logical := True;
    LIJ: Logical;
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop
        LIJ := LProperty(T(I,J));
        if LIJ=False then return False; end if;
        if LIJ=Uncertain then L := Uncertain; end if;
      end loop;
    end loop;
    return L;
  end TF_LProperty;
  
  function TF_BSimilar(T1,T2: Triangular) return Boolean is
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop
        if not BSimilar(T1(I,J),T2(I,J)) then return False; end if;
      end loop;
    end loop;
    return True;
  end TF_BSimilar;
  
  function TF_LSimilar(T1,T2: Triangular) return Logical is
    L: Logical := True;
    LIJ: Logical;
  begin
    for I in Power loop
      for J in 0 .. PDeg-I loop
        LIJ := LSimilar(T1(I,J),T2(I,J));
        if LIJ=False then return False; end if;
        if LIJ=Uncertain then L := Uncertain; end if;
      end loop;
    end loop;
    return L;
  end TF_LSimilar;
    
end Triangulars.TGeneric;
