with Logicals;
use Logicals;

pragma Elaborate_All (Logicals);

generic
  
  PDeg: in Positive;

package Triangulars.TGeneric is --- component-wise triangular operations
  
  generic
    with procedure Modify1(C: in out Scalar);
  procedure TP_Modify1(T: in out Triangular);
  
  generic
    with procedure Modify2(C1,C2: in out Scalar);
  procedure TP_Modify2(T1,T2: in out Triangular);
  
  generic
    with procedure Map1(C1: in Scalar; C2: in out Scalar);
  procedure TP_Map1(T1: in Triangular; T2: in out Triangular);
  
  generic
    with procedure Map1(C1: in Scalar; C2: in out Scalar);
  function TF_Map1(T: Triangular) return Triangular;
  
  generic
    with procedure Map2(C1,C2: in Scalar; C3: in out Scalar);
  procedure TP_Map2(T1,T2: in Triangular; T3: in out Triangular);
  
  generic
    with procedure Map2(C1,C2: in Scalar; C3: in out Scalar);
  function TF_Map2(T1,T2: Triangular) return Triangular;
  
  generic
    with function BProperty(C: Scalar) return Boolean;
  function TF_BProperty(T: Triangular) return Boolean;
  
  generic
    with function LProperty(C: Scalar) return Logical;
  function TF_LProperty(T: Triangular) return Logical;
  
  generic
    with function BSimilar(C1,C2: Scalar) return Boolean;
  function TF_BSimilar(T1,T2: Triangular) return Boolean;
  
  generic
    with function LSimilar(C1,C2: Scalar) return Logical;
  function TF_LSimilar(T1,T2: Triangular) return Logical;
  
end Triangulars.TGeneric;
