with Ada.Text_IO, Strings, Ints, Flts, Paths, Globals;
use Ada.Text_IO, Ints, Flts, Paths, Globals;

procedure Write_Path is
  
  function Interpolate_Radius(NC: in Integer) return Integer is
  begin
    if NC <= 3000 then return 249; end if;
    if NC >= 16000 then return 134; end if;
    declare
      NR: Integer;
      C,R: IntVec(0 .. 15);
      X,Y: FltVec(0..3);
    begin      
      C( 0) :=     0;  R( 0) := 512;
      C( 1) :=  3000;  R( 1) := 249;
      C( 2) :=  4000;  R( 2) := 159;
      C( 3) :=  5000;  R( 3) := 122;
      C( 4) :=  6000;  R( 4) := 116;
      C( 5) :=  7000;  R( 5) := 102;
      C( 6) :=  8000;  R( 6) :=  72;
      C( 7) :=  9000;  R( 7) :=  50;
      C( 8) := 10000;  R( 8) :=  31;
      C( 9) := 11000;  R( 9) :=  20;
      C(10) := 12000;  R(10) :=  37;
      C(11) := 13000;  R(11) :=  59;
      C(12) := 14000;  R(12) := 101;
      C(13) := 15000;  R(13) := 121;
      C(14) := 16000;  R(14) := 134;
      C(15) := 16500;  R(15) := 140;
--      C(15) := 16500;  R(15) := 141;
      for I in reverse 1 .. C'Last-2 loop
        if NC>C(I) then
          X := (Flt(C(I-1)),Flt(C(I)),Flt(C(I+1)),Flt(C(I+2)));
          Y := (Flt(R(I-1)),Flt(R(I)),Flt(R(I+1)),Flt(R(I+2)));
          NR := Integer(Interpolate(X,Y,Flt(NC)));
          return NR;
        end if;
      end loop;
    end;
    return 0;
  end Interpolate_Radius;
  
  function Guess_Radius(NC: in Integer) return Integer is
  begin
    return (Interpolate_Radius(NC)*13)/16;
  end Guess_Radius;
  
  procedure Plot_Radii is
    use Paths;
  begin
    for N in 0 .. N_End/10 loop
      Plot2("guessed_radii",Flt(10*N),Flt(Guess_Radius(10*N)));
    end loop;
  end Plot_Radii;
  
  N,M,R,L: Natural := 1;
  P: Path(1..512);
  
begin
  Verbosity := 1;
  
  P(1) := (0,512,0);
  if Verbosity>0 then Show2("step ",0,512); end if;
  N := 512;
  loop
    M := N;
    loop
      M := M+1;
      exit when M-Guess_Radius(M) >= N;
    end loop;
    N := M-1;
    R := Guess_Radius(N);
    L := L+1;
    P(L) := (N,R,0);
    if Verbosity>0 then Show2("step ",N-R,N+R); end if;
    N := N+R;
    exit when N>N_End;
  end loop;
  Write(Output_Dir & "path.orig",P,L);
  Write(Output_Dir & "path",P,L);
  
  Plot_Radii;
  
end Write_Path;


